VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Column"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable(s) to hold property value(s)
Private mvarColumnName As String 'local copy
Public Enum xgColumnType
    xgString = 0
    xgNumber = 1
    xgDate = 2
    xgVariant = 3
End Enum
Private mvarColumnType As xgColumnType 'local copy
Private mvarColumnValue As Variant 'local copy
Private mvarBoundListColumn As Variant 'local copy
Private mvarShowedListColumn As Variant 'local copy
'local variable(s) to hold property value(s)
Private mvarListRecordset As ADODB.Recordset 'local copy
'local variable(s) to hold property value(s)
Private mvarColWidth As Long 'local copy
'local variable(s) to hold property value(s)
Private mvarCheckBox As Boolean 'local copy
'local variable(s) to hold property value(s)
Private mvarLocked As Boolean 'local copy
'local variable(s) to hold property value(s)
Private mvarListLocked As Boolean 'local copy
Public Property Let ListLocked(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ListLocked = 5
    mvarListLocked = vData
End Property


Public Property Get ListLocked() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ListLocked
    ListLocked = mvarListLocked
End Property



Public Property Let Locked(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Locked = 5
    mvarLocked = vData
End Property


Public Property Get Locked() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Locked
    Locked = mvarLocked
End Property



Public Property Let CheckBox(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.CheckBox = 5
    mvarCheckBox = vData
    
    If Not InAddCol Then
        MyReference.Redraw
    End If
End Property


Public Property Get CheckBox() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.CheckBox
    CheckBox = mvarCheckBox
End Property



Public Property Let ColWidth(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ColWidth = 5
    mvarColWidth = vData
    If Not InAddCol Then
        MyReference.Redraw
    End If
End Property


Public Property Get ColWidth() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ColWidth
    ColWidth = mvarColWidth
End Property




Public Property Set ListRecordset(ByVal vData As ADODB.Recordset)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.ListRecordset = Form1
    Set mvarListRecordset = vData
    
    If Not vData Is Nothing Then
        RefreshData
    End If
End Property

Private Sub RefreshData()
    Dim i As Long
    
    On Error GoTo errHandler
    
    If InAddCol Or mvarListRecordset Is Nothing Or IsMissing(mvarBoundListColumn) Or IsMissing(mvarShowedListColumn) Then
        Exit Sub
    End If
    
    For i = 1 To m_Rows.Count
        m_Rows(i).Field(mvarColumnName).FieldValue = m_Rows(i).Field(mvarColumnName).FieldValue
    Next i
    
errHandler:
End Sub

Public Property Get ListRecordset() As ADODB.Recordset
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ListRecordset

    Set ListRecordset = mvarListRecordset

End Property




Public Property Let ShowedListColumn(ByVal vData As Variant)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ShowedListColumn = 5
    mvarShowedListColumn = vData
    
    If Not IsMissing(vData) Then
        RefreshData
    End If
End Property


Public Property Set ShowedListColumn(ByVal vData As Variant)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.ShowedListColumn = Form1
    Set mvarShowedListColumn = vData
End Property


Public Property Get ShowedListColumn() As Variant
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ShowedListColumn
    If IsObject(mvarShowedListColumn) Then
        Set ShowedListColumn = mvarShowedListColumn
    Else
        ShowedListColumn = mvarShowedListColumn
    End If
End Property



Public Property Let BoundListColumn(ByVal vData As Variant)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.BoundListColumn = 5
    mvarBoundListColumn = vData
    
    If Not IsMissing(vData) Then
        RefreshData
    End If
End Property


Public Property Set BoundListColumn(ByVal vData As Variant)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.BoundListColumn = Form1
    Set mvarBoundListColumn = vData
End Property


Public Property Get BoundListColumn() As Variant
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.BoundListColumn
    If IsObject(mvarBoundListColumn) Then
        Set BoundListColumn = mvarBoundListColumn
    Else
        BoundListColumn = mvarBoundListColumn
    End If
End Property



Public Property Let ColumnValue(ByVal vData As Variant)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ColumnValue = 5
    mvarColumnValue = vData
    If Not InAddCol Then
        MyReference.Redraw
    End If
End Property





Public Property Get ColumnValue() As Variant
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ColumnValue
    If IsObject(mvarColumnValue) Then
        Set ColumnValue = mvarColumnValue
    Else
        ColumnValue = mvarColumnValue
    End If
End Property



Public Property Let ColumnType(ByVal vData As xgColumnType)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ColumnType = 5
    mvarColumnType = vData
End Property


Public Property Get ColumnType() As xgColumnType
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ColumnType
    ColumnType = mvarColumnType
End Property




Public Property Let ColumnName(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ColumnName = 5
    Dim i As Long
    
    For i = 1 To m_Columns.Count
        If LCase(m_Columns(i).ColumnName) = LCase(vData) Then
            Exit Property
        End If
    Next i
    
    mvarColumnName = vData
    If Not InAddCol Then
        MyReference.Redraw
    End If
End Property


Public Property Get ColumnName() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ColumnName
    ColumnName = mvarColumnName
End Property



