VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Columns"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Column"
Attribute VB_Ext_KEY = "Member0" ,"Column"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable to hold collection
Private mCol As Collection

Public Function Add(ColumnName As String, _
                            Optional ColumnType As xgColumnType, _
                            Optional ColumnValue As Variant, _
                            Optional ListRecordset As ADODB.Recordset, _
                            Optional BoundListColumn As Variant, _
                            Optional ShowedListColumn As Variant) As Column
                            
    'create a new object
    Dim objNewMember As Column
    Dim J As Long
    Dim i As Long
    Dim Value As Variant
    
    InAddCol = True
    
    For i = 1 To m_Columns.Count
        If LCase(ColumnName) = LCase(m_Columns(i).ColumnName) Then Exit Function
    Next i
    
    Set objNewMember = New Column


    'set the properties passed into the method

    objNewMember.ColumnName = ColumnName
    objNewMember.ColumnType = ColumnType
    objNewMember.ColWidth = 100
    
    Set objNewMember.ListRecordset = ListRecordset
    
    If IsObject(ColumnValue) Then
        Set objNewMember.ColumnValue = ColumnValue
    Else
        objNewMember.ColumnValue = ColumnValue
    End If
    If IsObject(BoundListColumn) Then
        Set objNewMember.BoundListColumn = BoundListColumn
    Else
        objNewMember.BoundListColumn = BoundListColumn
    End If
    If IsObject(ShowedListColumn) Then
        Set objNewMember.ShowedListColumn = ShowedListColumn
    Else
        objNewMember.ShowedListColumn = ShowedListColumn
    End If
    
    mCol.Add objNewMember, ColumnName



    'return the object created
    Set Add = objNewMember
    
    InAddRow = True
    
    For i = 1 To m_Rows.Count
        Select Case objNewMember.ColumnType
            Case xgDate
                Value = CDate(0)
            Case xgNumber
                Value = 0
            Case xgString
                Value = ""
        End Select
        
        m_Rows.Item(i).AddField objNewMember.ColumnName, objNewMember.ColumnName, objNewMember.ColumnType, "", Value
    Next i
    
    For i = 1 To m_Deleted.Count
        Select Case objNewMember.ColumnType
            Case xgDate
                Value = CDate(0)
            Case xgNumber
                Value = 0
            Case xgString
                Value = ""
        End Select
        
        m_Deleted.Item(i).AddField objNewMember.ColumnName, objNewMember.ColumnName, objNewMember.ColumnType, "", Value
    Next i
    
    InAddRow = False
    
    MyReference.Redraw
    
    Set objNewMember = Nothing
    
    InAddCol = False
End Function

Public Property Get Item(vntIndexKey As Variant) As Column
Attribute Item.VB_UserMemId = 0
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set Item = mCol(vntIndexKey)
End Property

Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    Count = mCol.Count
End Property


Public Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)


    mCol.Remove vntIndexKey
End Sub

Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

