VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Deleted"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable to hold collection
Private mCol As Collection

Friend Function AddRow(Optional sKey As String, Optional mRow As Row) As Row
    'create a new object
    Dim objNewMember As Row
    Dim i As Integer
    Dim Fld As Field
    Dim Col As Column
    Dim Value As Variant
    
    InAddRow = True
    
    Set objNewMember = New Row


    'set the properties passed into the method
    
    If Not mRow Is Nothing Then
        Set objNewMember = mRow
    End If
    
    For i = 1 To m_Columns.Count
        Set Col = m_Columns(i)
        
        Select Case Col.ColumnType
            Case xgDate
                Value = CDate(0)
            Case xgNumber
                Value = 0
            Case xgString
                Value = ""
        End Select
        objNewMember.AddField Col.ColumnName, Col.ColumnName, Col.ColumnType, "", Value
    Next i
    
    objNewMember.Key = sKey
    
    If Len(sKey) = 0 Then
        mCol.Add objNewMember
    Else
        mCol.Add objNewMember, sKey
    End If


    'return the object created
    Set AddRow = objNewMember
    Set objNewMember = Nothing

    InAddRow = False
    
End Function

Public Property Get Item(vntIndexKey As Variant) As Row
Attribute Item.VB_UserMemId = 0
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set Item = mCol(vntIndexKey)
End Property



Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    Count = mCol.Count
End Property


Friend Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)


    mCol.Remove vntIndexKey
End Sub

Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub


